﻿<%@ Page Language="C#" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<script runat="server">
    enum UserType
    {
        Admin,
        Master,
        Guest = 5,
        Invalid
    }

    public struct Dog
    {
        public string Name;
        public string Breed;

        public Dog(string name, string breed)
        {
            Name = name;
            Breed = breed;
        }

        public string Introduce()
        {
            return "이름 : " + Name + "(" + Breed + ")";
        }
    }

    readonly int NumberOfGrade;
    // readonly static int NumberOfGrade = 4;

    class Customer
    {
        public string m_Name;
        private string m_SocialNumbr;

        public string GetSocialNumber()
        {
            return m_SocialNumbr;
        }

        public void SetSocialNumber(string sn)
        {
            if (!IsValidSocialNumber(sn))
                throw new ArgumentException(sn, "주민등록번호 오류");
            else m_SocialNumbr = sn;
        }

        public string SocialNumber
        {
            get { return m_SocialNumbr; }
            set
            {
                if (!IsValidSocialNumber(value))
                    throw new ArgumentException(value, "주민등록번호 오류");
                else m_SocialNumbr = value;
            }
        }

        private bool IsValidSocialNumber(string sn)
        {
            // 주민등록번호 형식을 점검하여 true/false 변환
            return true;
        }

        void MakeAccount() {}
        public string MakeAccount(int accountType)
        {
            return accountType.ToString();
        }
        void BearInterest() {}

        int SaveMoney(string accountNumber, int amount)
        {
            // for test
            int totalAmount = 0;
            totalAmount += amount;
            
            return totalAmount;
        }
    }
    
    /*
    class BestCustomer
    {
        string m_Name;
        string m_SocialNumbr;

        void MakeAccount() { }
        void BearInterest() { }
        void DrawCheck() { }
    }
     */

    // interface

    interface ICustomer
    {
        // 인터페이스에는 데이터를 저장하지 않기에 필드를 넣을 수 없다.
        // 대신 속성을 사용한다.
        string Name { get; set; }
        void MakeAccount();
    }

    /*
    abstract class Customer
    {
        string m_Name;
        abstract void MakeAccount();
    }

    class BestCustomer : Customer, ICustomer { }
    */
    
    class BestCustomer : Customer
    {
        BestCustomer() { }
        ~BestCustomer() { }
        
        void DrawCheck() { }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        int memberAge;
        string memberName;

        memberAge = 21;
        memberName = "관우";

        int newMemberAge;                   // 초기화되지 않은 변수
        // newMemberAge = newMemberAge + 1; // 컴파일 에러 발생

        // 실수형 데이터
        // float myFloat = 3.14F;
        double myDouble = 3.14;
        decimal myDecimal = 3.14M;
        
        // long형 데이터
        long myLong = 1234L;
        
        // 문자형 데이터
        char engValue = 'A';
        char korValue = '가';
        char chinaValue = '漢';
        
        // 논리형 데이터
        bool hasDone = true;

        UserType siteUserType = UserType.Guest;
        ShowResult(siteUserType + " = " + (int)siteUserType);
        
        // 사용자 정의형 구조체 사용
        Dog bob = new Dog("파대기", "Beagle");
        Dog tom;
        tom.Name = "쫑쫑이";
        tom.Breed = "Poodle";

        ShowResult(bob.Introduce());
        ShowResult(tom.Introduce());
        
        // 문자열 선언 및 초기화
        string firstString;
        firstString = "Web";
        string secondString = "Developer";
        
        // 문자열 합치기
        string stringConcatenation = firstString + " " + secondString + " 2010";
        ShowResult(stringConcatenation);

        string filePath = "C:\\ASPNET_Example\\03";
        // string filePath = @"C:\ASPNET_Example\03";

        // 3개의 문자열을 저장할 수 있는 배열의 선언
        string[] stringArray;
        stringArray = new string[3];
        
        // 2×3개(모두 6개)의 정수를 저장할 수 있는 배열의 선언과 메모리 할당
        int[,] intArray = new int[2, 3];
        
        // 배열에 값 저장하기
        stringArray[0] = "one";
        intArray[1, 2] = 100;
        
        // string[] stringArray = new string[3] { "one", "two", "three" };
        // int[,] intArray = new int[2, 3] { {1, 2, 3}, {4, 5, 6}};
        
        // string[] stringArray = { "one", "two", "three" };
        // int[,] intArray = {{1, 2, 3}, {4, 5, 6}};
        
        long[,] longArray;
        longArray = new long[,] {{1L, 2L, 3L}, {4L, 5L, 6L}};

        const int NumberOfGrade = 4;

        bool myBool = true;
        int myInt = 45;
        float myFloat = 7.8F;

        myFloat = myInt + myFloat;
        ShowResult("합은 " + myFloat + "입니다. (" + myBool + ")");

        int dividend = 7;
        int divisor = 5;

        int quotient = dividend / divisor;
        float quotientFloat = (float)dividend / (float)divisor;
        ShowResult(quotient + " vs " + quotientFloat);

        string stringValue = "7";
        myInt = int.Parse(stringValue);
        myInt = Convert.ToInt32(stringValue);

        stringValue = "7.8";
        myFloat = float.Parse(stringValue);
        myFloat = Convert.ToSingle(stringValue);

        myInt = 2;
        int result;

        result = +myInt; ShowResult(result.ToString());
        result = -myInt; ShowResult(result.ToString());
        result = ~myInt; ShowResult(result.ToString());

        myInt = 2;
        result = ++myInt;
        ShowResult(result + " vs " + myInt);

        myInt = 2;
        result = myInt++;
        ShowResult(result + " vs " + myInt);

        result = myInt--;
        ShowResult(result + " vs " + myInt);

        int firstOpr = 5;
        int secondOpr = 2;

        result = firstOpr * secondOpr; ShowResult(result.ToString());
        result = firstOpr / secondOpr; ShowResult(result.ToString());
        result = firstOpr % secondOpr; ShowResult(result.ToString());
        result = firstOpr + secondOpr; ShowResult(result.ToString());
        result = firstOpr - secondOpr; ShowResult(result.ToString());

        myInt = 2;
        myInt = myInt << 1;
        ShowResult(myInt.ToString());

        firstOpr = 2;
        secondOpr = 3;

        result = firstOpr & secondOpr; ShowResult(result.ToString());
        result = firstOpr | secondOpr; ShowResult(result.ToString());
        result = firstOpr ^ secondOpr; ShowResult(result.ToString());

        myInt = 1;
        int yourInt = 2;
        bool isBig = (++myInt > ++yourInt) & (++myInt > ++yourInt);
        ShowResult("myInr = " + myInt.ToString());

        myInt = 1;
        yourInt = 2;
        isBig = (++myInt > ++yourInt) && (++myInt > ++yourInt);
        ShowResult("myInr = " + myInt.ToString());
        
        // if 문
        int score = 180;
        string stringResult = "";
        if (score > 100 && score <= 200)
        {
            if (score > 170) stringResult = "참 ";
            stringResult = stringResult + "잘했습니다.";
        }
        else stringResult = "노력바랍니다.";
        ShowResult(stringResult);

        int[] intArray_01 = { 1, 2, 3 };
        int total = 0;
        foreach (int item in intArray_01)
        {
            total += item;
        }
        ShowResult("합 = " + total);

        myInt = 0;
        while (myInt < 10)
        {
            myInt++;
        }
        ShowResult("myInt = " + myInt);

        myInt = 0;
        do
        {
            myInt++;
        } while (myInt < 10);
        ShowResult("myInt = " + myInt);

        myInt = 0;
    MatchFour:
        myInt++;

        if (myInt == 5) goto LoopOut;
        for (int i = 0; i < 10; i++)
        {
            if (i == 4) goto MatchFour;
        }
    LoopOut:
        ShowResult("블록 1이 5번씩 5번 수행");

        myInt = 0;
        int sum = 0;
        while (true)
        {
            myInt++;
            if (myInt % 3 == 0) continue;
            sum += myInt;
            if (sum > 100) break;
        }
        ShowResult("3의 배수를 제외한 수의 합이 100이 넘었습니다.");

        try
        {
            stringValue = "7.8";
            myInt = int.Parse(stringValue);
        }
        catch
        {
            ShowResult("예외 현상 발생");
        }

        Customer myCustomer = new Customer();
        myCustomer.m_Name = "홍길동";
        string accountType = myCustomer.MakeAccount(3);
        ShowResult("고객명: " + myCustomer.m_Name + ", 계좌 종류 코드: " + accountType);

        myCustomer.SetSocialNumber("111111-1111111");
        // 혹은 myCustomer.SocialNumber = "111111-1111111";
        ShowResult(myCustomer.GetSocialNumber());
    }

    void ShowResult(string result)
    {
        Label lblResult = new Label();
        Page.Controls.Add(lblResult);
        lblResult.Text = result + " <br />";
    }
</script>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
</head>
<body>
    <form id="form1" runat="server">
    <div>
    
    </div>
    </form>
</body>
</html>
